"use strict";

var _GraphVertex = _interopRequireDefault(require("../../../../data-structures/graph/GraphVertex"));

var _GraphEdge = _interopRequireDefault(require("../../../../data-structures/graph/GraphEdge"));

var _Graph = _interopRequireDefault(require("../../../../data-structures/graph/Graph"));

var _topologicalSort = _interopRequireDefault(require("../topologicalSort"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('topologicalSort', () => {
  it('should do topological sorting on graph', () => {
    const vertexA = new _GraphVertex.default('A');
    const vertexB = new _GraphVertex.default('B');
    const vertexC = new _GraphVertex.default('C');
    const vertexD = new _GraphVertex.default('D');
    const vertexE = new _GraphVertex.default('E');
    const vertexF = new _GraphVertex.default('F');
    const vertexG = new _GraphVertex.default('G');
    const vertexH = new _GraphVertex.default('H');
    const edgeAC = new _GraphEdge.default(vertexA, vertexC);
    const edgeBC = new _GraphEdge.default(vertexB, vertexC);
    const edgeBD = new _GraphEdge.default(vertexB, vertexD);
    const edgeCE = new _GraphEdge.default(vertexC, vertexE);
    const edgeDF = new _GraphEdge.default(vertexD, vertexF);
    const edgeEF = new _GraphEdge.default(vertexE, vertexF);
    const edgeEH = new _GraphEdge.default(vertexE, vertexH);
    const edgeFG = new _GraphEdge.default(vertexF, vertexG);
    const graph = new _Graph.default(true);
    graph.addEdge(edgeAC).addEdge(edgeBC).addEdge(edgeBD).addEdge(edgeCE).addEdge(edgeDF).addEdge(edgeEF).addEdge(edgeEH).addEdge(edgeFG);
    const sortedVertices = (0, _topologicalSort.default)(graph);
    expect(sortedVertices).toBeDefined();
    expect(sortedVertices.length).toBe(graph.getAllVertices().length);
    expect(sortedVertices).toEqual([vertexB, vertexD, vertexA, vertexC, vertexE, vertexH, vertexF, vertexG]);
  });
});