"use strict";

var _linearSearch = _interopRequireDefault(require("../linearSearch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('linearSearch', () => {
  it('should search all numbers in array', () => {
    const array = [1, 2, 4, 6, 2];
    expect((0, _linearSearch.default)(array, 10)).toEqual([]);
    expect((0, _linearSearch.default)(array, 1)).toEqual([0]);
    expect((0, _linearSearch.default)(array, 2)).toEqual([1, 4]);
  });
  it('should search all strings in array', () => {
    const array = ['a', 'b', 'a'];
    expect((0, _linearSearch.default)(array, 'c')).toEqual([]);
    expect((0, _linearSearch.default)(array, 'b')).toEqual([1]);
    expect((0, _linearSearch.default)(array, 'a')).toEqual([0, 2]);
  });
  it('should search through objects as well', () => {
    const comparatorCallback = (a, b) => {
      if (a.key === b.key) {
        return 0;
      }

      return a.key <= b.key ? -1 : 1;
    };

    const array = [{
      key: 5
    }, {
      key: 6
    }, {
      key: 7
    }, {
      key: 6
    }];
    expect((0, _linearSearch.default)(array, {
      key: 10
    }, comparatorCallback)).toEqual([]);
    expect((0, _linearSearch.default)(array, {
      key: 5
    }, comparatorCallback)).toEqual([0]);
    expect((0, _linearSearch.default)(array, {
      key: 6
    }, comparatorCallback)).toEqual([1, 3]);
  });
});