"use strict";

var _MergeSort = _interopRequireDefault(require("../MergeSort"));

var _SortTester = require("../../SortTester");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Complexity constants.
const SORTED_ARRAY_VISITING_COUNT = 79;
const NOT_SORTED_ARRAY_VISITING_COUNT = 102;
const REVERSE_SORTED_ARRAY_VISITING_COUNT = 87;
const EQUAL_ARRAY_VISITING_COUNT = 79;
describe('MergeSort', () => {
  it('should sort array', () => {
    _SortTester.SortTester.testSort(_MergeSort.default);
  });
  it('should sort array with custom comparator', () => {
    _SortTester.SortTester.testSortWithCustomComparator(_MergeSort.default);
  });
  it('should do stable sorting', () => {
    _SortTester.SortTester.testSortStability(_MergeSort.default);
  });
  it('should sort negative numbers', () => {
    _SortTester.SortTester.testNegativeNumbersSort(_MergeSort.default);
  });
  it('should visit EQUAL array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_MergeSort.default, _SortTester.equalArr, EQUAL_ARRAY_VISITING_COUNT);
  });
  it('should visit SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_MergeSort.default, _SortTester.sortedArr, SORTED_ARRAY_VISITING_COUNT);
  });
  it('should visit NOT SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_MergeSort.default, _SortTester.notSortedArr, NOT_SORTED_ARRAY_VISITING_COUNT);
  });
  it('should visit REVERSE SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_MergeSort.default, _SortTester.reverseArr, REVERSE_SORTED_ARRAY_VISITING_COUNT);
  });
});