"use strict";

var _QuickSortInPlace = _interopRequireDefault(require("../QuickSortInPlace"));

var _SortTester = require("../../SortTester");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Complexity constants.
const SORTED_ARRAY_VISITING_COUNT = 19;
const NOT_SORTED_ARRAY_VISITING_COUNT = 12;
const REVERSE_SORTED_ARRAY_VISITING_COUNT = 19;
const EQUAL_ARRAY_VISITING_COUNT = 19;
describe('QuickSortInPlace', () => {
  it('should sort array', () => {
    _SortTester.SortTester.testSort(_QuickSortInPlace.default);
  });
  it('should sort array with custom comparator', () => {
    _SortTester.SortTester.testSortWithCustomComparator(_QuickSortInPlace.default);
  });
  it('should sort negative numbers', () => {
    _SortTester.SortTester.testNegativeNumbersSort(_QuickSortInPlace.default);
  });
  it('should visit EQUAL array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_QuickSortInPlace.default, _SortTester.equalArr, EQUAL_ARRAY_VISITING_COUNT);
  });
  it('should visit SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_QuickSortInPlace.default, _SortTester.sortedArr, SORTED_ARRAY_VISITING_COUNT);
  });
  it('should visit NOT SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_QuickSortInPlace.default, _SortTester.notSortedArr, NOT_SORTED_ARRAY_VISITING_COUNT);
  });
  it('should visit REVERSE SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_QuickSortInPlace.default, _SortTester.reverseArr, REVERSE_SORTED_ARRAY_VISITING_COUNT);
  });
});