"use strict";

var _RadixSort = _interopRequireDefault(require("../RadixSort"));

var _SortTester = require("../../SortTester");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Complexity constants.
const ARRAY_OF_STRINGS_VISIT_COUNT = 24;
const ARRAY_OF_INTEGERS_VISIT_COUNT = 77;
describe('RadixSort', () => {
  it('should sort array', () => {
    _SortTester.SortTester.testSort(_RadixSort.default);
  });
  it('should visit array of strings n (number of strings) x m (length of longest element) times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_RadixSort.default, ['zzz', 'bb', 'a', 'rr', 'rrb', 'rrba'], ARRAY_OF_STRINGS_VISIT_COUNT);
  });
  it('should visit array of integers n (number of elements) x m (length of longest integer) times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_RadixSort.default, [3, 1, 75, 32, 884, 523, 4343456, 232, 123, 656, 343], ARRAY_OF_INTEGERS_VISIT_COUNT);
  });
});