"use strict";

var _ShellSort = _interopRequireDefault(require("../ShellSort"));

var _SortTester = require("../../SortTester");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Complexity constants.
const SORTED_ARRAY_VISITING_COUNT = 320;
const NOT_SORTED_ARRAY_VISITING_COUNT = 320;
const REVERSE_SORTED_ARRAY_VISITING_COUNT = 320;
const EQUAL_ARRAY_VISITING_COUNT = 320;
describe('ShellSort', () => {
  it('should sort array', () => {
    _SortTester.SortTester.testSort(_ShellSort.default);
  });
  it('should sort array with custom comparator', () => {
    _SortTester.SortTester.testSortWithCustomComparator(_ShellSort.default);
  });
  it('should sort negative numbers', () => {
    _SortTester.SortTester.testNegativeNumbersSort(_ShellSort.default);
  });
  it('should visit EQUAL array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_ShellSort.default, _SortTester.equalArr, EQUAL_ARRAY_VISITING_COUNT);
  });
  it('should visit SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_ShellSort.default, _SortTester.sortedArr, SORTED_ARRAY_VISITING_COUNT);
  });
  it('should visit NOT SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_ShellSort.default, _SortTester.notSortedArr, NOT_SORTED_ARRAY_VISITING_COUNT);
  });
  it('should visit REVERSE SORTED array element specified number of times', () => {
    _SortTester.SortTester.testAlgorithmTimeComplexity(_ShellSort.default, _SortTester.reverseArr, REVERSE_SORTED_ARRAY_VISITING_COUNT);
  });
});