"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _BinarySearchTreeNode = _interopRequireDefault(require("./BinarySearchTreeNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class BinarySearchTree {
  /**
   * @param {function} [nodeValueCompareFunction]
   */
  constructor(nodeValueCompareFunction) {
    this.root = new _BinarySearchTreeNode.default(null, nodeValueCompareFunction); // Steal node comparator from the root.

    this.nodeComparator = this.root.nodeComparator;
  }
  /**
   * @param {*} value
   * @return {BinarySearchTreeNode}
   */


  insert(value) {
    return this.root.insert(value);
  }
  /**
   * @param {*} value
   * @return {boolean}
   */


  contains(value) {
    return this.root.contains(value);
  }
  /**
   * @param {*} value
   * @return {boolean}
   */


  remove(value) {
    return this.root.remove(value);
  }
  /**
   * @return {string}
   */


  toString() {
    return this.root.toString();
  }

}

exports.default = BinarySearchTree;